#ifndef POINTERS_H
#define POINTERS_H

#include "../../misc/log_time.h"
#include "common.h"

// This header defines safe pointers (java style references)
// for shared objects

class FlOObject;
//class FlOService;
class FlOServiceRemote;

class pFlOObject: public pSafeObject {
 public:
  pFlOObject(void) {
    odlog(4)<<"pFlOObject: constructor: NULL: "<<this<<endl;
  };
  pFlOObject(FlOObject& o):pSafeObject((SafeObject&)o) {
    odlog(4)<<"pFlOObject: constructor: objecti "<<this<<endl;
  };
  pFlOObject(FlOObject* o):pSafeObject((SafeObject*)o) {
    odlog(4)<<"pFlOObject: constructor: pointer: "<<this<<endl;
  };
  pFlOObject(const pFlOObject& p):pSafeObject(p) {
    odlog(4)<<"pFlOObject: constructor: safe pointer: "<<this<<endl;
  };
  FlOObject& operator*(void) const { return *(FlOObject*)object_; };
  FlOObject* operator->(void) const { return (FlOObject*)object_; };
};

class const_pFlOObject: public pSafeObject {
 public:
  const_pFlOObject(void) {
    odlog(4)<<"const_pFlOObject: constructor: NULL: "<<this<<endl;
  };
  const_pFlOObject(const FlOObject& o):pSafeObject((SafeObject&)o) {
    odlog(4)<<"const_pFlOObject: constructor: object: "<<this<<endl;
  };
  const_pFlOObject(const FlOObject* o):pSafeObject((SafeObject*)o) {
    odlog(4)<<"const_pFlOObject: constructor: pointer: "<<this<<endl;
  };
  const_pFlOObject(const const_pFlOObject& p):pSafeObject(p) {
    odlog(4)<<"const_pFlOObject: constructor: safe_pointer: "<<this<<endl;
  };
  const_pFlOObject(const pFlOObject& p):pSafeObject(p) {
    odlog(4)<<"const_pFlOObject: constructor: safe_pointer: "<<this<<endl;
  };
  const FlOObject& operator*(void) const { return *(const FlOObject*)object_; };
  const FlOObject* operator->(void) const { return (const FlOObject*)object_; };
};

class pFlOServiceRemote: public pSafeObject {
 public:
  pFlOServiceRemote(void) { };
  pFlOServiceRemote(FlOServiceRemote& o):pSafeObject((SafeObject&)o) { };
  pFlOServiceRemote(FlOServiceRemote* o):pSafeObject((SafeObject*)o) { };
  pFlOServiceRemote(const pFlOServiceRemote& p):pSafeObject(p) { };
  FlOServiceRemote& operator*(void) const { return *(FlOServiceRemote*)object_; };
  FlOServiceRemote* operator->(void) const { return (FlOServiceRemote*)object_; };
};

//class pFlOService: public pSafeObject {
// public:
//  pFlOService(void) { };
//  pFlOService(FlOService& o):pSafeObject((SafeObject&)o) { };
//  pFlOService(pFlOService& p):pSafeObject(p) { };
//  FlOService& operator*(void) const { return *(FlOService*)object_; };
//  FlOService* operator->(void) const { return (FlOService*)object_; };
//};

#endif // POINTERS_H
