#include "httpsd.h"
#include "server/service_soap.h"

#include "jobs/jobs_soapH.h"

#include "../gridftp/fileroot.h"

class HTTP_JobControl_Handle;

class HTTP_JobControl: public HTTP_ServiceAdv {
 friend int nj__createJobs(struct soap*,int,nj__jobdefinition*, __jobsinfo&);
 friend int nj__createJob(struct soap*,nj__jobdefinition*,nj__jobinfo&);
 friend int nj__queryJob(struct soap*,nj__jobinfo&);
 friend int nj__cancelJob(struct soap*,nj__jobinfo&);
 friend int nj__cleanJob(struct soap*,nj__jobinfo&);
 friend int nj_modifyJob(struct soap*,nj__jobinfo*,nj__jobinfo&);
 private:
  FilePlugin *jobplugin;
  userspec_t userspec;
  string service_url;
  string job_id;
  bool job_only;
 public:
  HTTP_JobControl(HTTP_Connector *c,const char* uri,HTTP_JobControl_Handle& handle);
  virtual ~HTTP_JobControl(void);
  virtual HTTP_Error get(const char* uri,int &keep_alive);
  virtual HTTP_Error put(const char* uri,int &keep_alive);
  virtual HTTP_Error post(const char* uri,int &keep_alive);
  virtual void soap_methods(void);
};

HTTP_Service* jobs_service_creator(HTTP_Connector& c,const char* uri,void* arg);
bool jobs_service_configurator(istream& f,const char* uri,HTTP_Service_Properties &prop);

